LeetCode_双指针_中等_809.情感丰富的文字

目录

  • 1.题目
  • 2.思路
  • 3.代码实现(Java)

1.题目

有时候人们会用重复写一些字母来表示额外的感受,比如 “hello” -> “heeellooo”, “hi” -> “hiii”。我们将相邻字母都相同的一串字符定义为相同字母组,例如:“h”, “eee”, “ll”, “ooo”。

对于一个给定的字符串 S ,如果另一个单词能够通过将一些字母组扩张从而使其和 S 相同,我们将这个单词定义为可扩张的(stretchy)。扩张操作定义如下:选择一个字母组(包含字母 c ),然后往其中添加相同的字母 c 使其长度达到 3 或以上。

例如,以 “hello” 为例,我们可以对字母组 “o” 扩张得到 “hellooo”,但是无法以同样的方法得到 “helloo” 因为字母组 “oo” 长度小于 3。此外,我们可以进行另一种扩张 “ll” -> “lllll” 以获得 “helllllooo”。如果 S = “helllllooo”,那么查询词 “hello” 是可扩张的,因为可以对它执行这两种扩张操作使得 query = “hello” -> “hellooo” -> “helllllooo” = S。

输入一组查询单词,输出其中可扩张的单词数量。

示例:
输入:
S = “heeellooo”
words = [“hello”, “hi”, “helo”]
输出:1
解释:
我们能通过扩张 “hello” 的 “e” 和 “o” 来得到 “heeellooo”。
我们不能通过扩张 “helo” 来得到 “heeellooo” 因为 “ll” 的长度小于 3 。

提示:
0 <= len(S) <= 100。
0 <= len(words) <= 100。
0 <= len(words[i]) <= 100。
S 和所有在 words 中的单词都只由小写字母组成。

来源:力扣(LeetCode)
链接:https://leetcode.cn/problems/expressive-words

2.思路

(1)双指针
思路本题官方题解。

① 遍历数组 words,依次判断每个 word 是否可扩展得到 s,如果可以,则用变量 res 记录其个数;

② 为了方便,我们可以创建函数 isExpand(String s, String word) 来判断 s 是否可由 word 扩展得到,如果可以则返回 true,否则返回 false。其具体判断细节如下:
1)定义分别指向 s 和 word 的双指针 i 和 j,其初始值均为 0;
2)首先需要判断 s[i] 是否和 word[i] 相等,如果不相等,那么说明 s 不能由 word 扩展得到,直接返回 false 即可;
3)之后再不断向右移动 i 和 j,直到移动到与之前不同的字母,或者超出字符串的边界。假设 s 有 cntSc 个相同的字符,word 有 cntWc 个相同的字符,那么如果如下条件成立,则说明 s 不能由 word 扩展得到:

/*
	cntSc < cntWc: 此时 word 中连续字符 sc 的数量大于 s 中的,更加不可能通过扩展得到
	cntSc != cntWc && cntSc < 3: s 中连续字符 sc 的数量小于 3,而扩展必须达到 3 或以上,所以 s 不可能由 word 扩展得到
*/
cntSc < cntWc || (cntSc != cntWc && cntSc < 3)

4)当前某一个指针超出边界时,此时就退出上述的判断过程,而如果另外一个指针恰好也超出边界,那么说明对 s 和 word 的遍历同时完成,即 s 可由 word 扩展得到,返回 true;否则返回 false。

3.代码实现(Java)

//思路1————双指针
class Solution {
    public int expressiveWords(String s, String[] words) {
        int res = 0;
        for (String word : words) {
            if (isExpand(s, word)) {
                res++;
            }
        }
        return res;
    }

    //判断 s 是否可由 word 扩展得到,如果可以则返回 true,否则返回 false
    private boolean isExpand(String s, String word) {
        int i = 0;
        int j = 0;
        int sLen = s.length();
        int wLen = word.length();
        while (i < sLen && j < wLen) {
            if (s.charAt(i) != word.charAt(j)) {
                //只要有对应的字符不相等,则说明 s 不能由 word 扩展得到
                return false;
            }
            char sc = s.charAt(i);
            //计算 s 中连续字符 sc 的个数
            int cntSc = 0;
            while (i < sLen && s.charAt(i) == sc) {
                cntSc++;
                i++;
            }
            //计算 word 中连续字符 sc 的个数
            int cntWc = 0;
            while (j < wLen && word.charAt(j) == sc) {
                cntWc++;
                j++;
            }
            /*
				cntSc < cntWc: 此时 word 中连续字符 sc 的数量大于 s 中的,更加不可能通过扩展得到
				cntSc != cntWc && cntSc < 3: s 中连续字符 sc 的数量小于 3,而扩展必须达到 3 或以上,所以 s 不可能由 word 扩展得到
			*/
            if (cntSc < cntWc || (cntSc != cntWc && cntSc < 3)) {
                return false;
            }
        }
        return i == sLen && j == wLen;
    }
}

你可能感兴趣的:(LeetCode,算法刷题,leetcode,双指针)